var defineProperty = function defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
};

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};

var createTypes = function createTypes(names) {
  var mergeLists = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return Object.keys(mergeLists).reduce(function (types, name) {
    return _extends({}, types, defineProperty({}, name, mergeLists[name].reduce(function (flag, key) {
      return flag | types[key];
    }, 0)));
  }, names.reduce(function (types, name, i) {
    return _extends({}, types, defineProperty({}, name, 1 << i));
  }, {}));
};

var upFlag = function upFlag(flag, type) {
  return flag | type;
};

var downFlag = function downFlag(flag, type) {
  return flag & ~type;
};

var eq = function eq(flag, type) {
  return flag === type;
};

var all = function all(flag, type) {
  return (flag & type) === type;
};

var any = function any(flag, type) {
  return (flag & type) > 0;
};

var notOne = function notOne(flag, type) {
  return (flag & type) === 0;
};

var notAll = function notAll(flag, type) {
  return (flag & type) !== type;
};

/* eslint-disable */
function assign (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
}

var defineProperty$1 = function (obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
};

var _extends$1 = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};

var index = {
  install: function install(Vue, _ref) {
    var _babelHelpers$extends;

    var _ref$prefix = _ref.prefix,
        prefix = _ref$prefix === undefined ? '$' : _ref$prefix,
        _ref$types = _ref.types,
        types = _ref$types === undefined ? {} : _ref$types;

    assign(Vue.prototype, _extends$1({}, types, (_babelHelpers$extends = {}, defineProperty$1(_babelHelpers$extends, prefix + 'eq', eq), defineProperty$1(_babelHelpers$extends, prefix + 'all', all), defineProperty$1(_babelHelpers$extends, prefix + 'any', any), defineProperty$1(_babelHelpers$extends, prefix + 'notOne', notOne), defineProperty$1(_babelHelpers$extends, prefix + 'notAll', notAll), _babelHelpers$extends)));
  }
};

export default index;
export { createTypes, upFlag, downFlag, eq, all, any, notOne, notAll };
